package com.example.PersonalCenter;

import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.appcompat.app.ActionBar;
import androidx.appcompat.app.AppCompatActivity;
import androidx.appcompat.widget.Toolbar;
import androidx.fragment.app.Fragment;
import androidx.fragment.app.FragmentStatePagerAdapter;
import androidx.viewpager.widget.ViewPager;

import com.example.PersonalCenter.Login_Register.LoginActivity;
import com.example.Util.User;
import com.example.cmknowledgegraph.MainActivity;
import com.example.cmknowledgegraph.R;
import com.github.florent37.materialviewpager.MaterialViewPager;
import com.github.florent37.materialviewpager.header.HeaderDesign;

import de.hdodenhof.circleimageview.CircleImageView;

public class MyPersonCenter extends Fragment {
    private CircleImageView iv_avatar;
    private TextView iv_avatar_username;


    MainActivity mainActivity;
    @Override
    public void onAttach(Context context) {
        super.onAttach(context);
        this.mainActivity = (MainActivity) context;
    }

    @Nullable
    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        return inflater.inflate(R.layout.chat_content, container, false);
    }

    @Override
    public void onActivityCreated(@Nullable Bundle savedInstanceState) {
        super.onActivityCreated(savedInstanceState);
        //包装处理逻辑
        //得到MaterViewPager实例
        iv_avatar = mainActivity.findViewById(R.id.iv_avatar);
        iv_avatar_username = mainActivity.findViewById(R.id.iv_avatar_username);
        iv_avatar.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(!User.isLogin){
                    Intent intent=new Intent();
                    intent.setClass(getActivity(), LoginActivity.class);
                    startActivity(intent);
                }
            }
        });
        MaterialViewPager materialViewPager = (MaterialViewPager) getActivity().findViewById(R.id.materialViewPager);
        //为MaterialViewPager添加监听
        materialViewPager.setMaterialViewPagerListener(new MaterialViewPager.Listener() {
            @Override
            //设置转换动画和图片，颜色
            public HeaderDesign getHeaderDesign(int page) {
                switch (page){
                    case 0:
                        return HeaderDesign.fromColorResAndDrawable(
                                R.color.blue,
                                getResources().getDrawable(R.drawable.xiha1)
                        );
                    case 1:
                        return HeaderDesign.fromColorResAndDrawable(
                                R.color.green,
                                getResources().getDrawable(R.drawable.xiha2)
                        );
                    case 2:
                        return HeaderDesign.fromColorResAndDrawable(
                                R.color.cyan,
                                getResources().getDrawable(R.drawable.xiha3)
                        );
                }

                return null;
            }
        });
        //设置Toolbar
        Toolbar toolbar = materialViewPager.getToolbar();
        if(toolbar!=null){
            mainActivity.setSupportActionBar(toolbar);
            ActionBar actionBar = mainActivity.getSupportActionBar();
            actionBar.setDisplayHomeAsUpEnabled(true);
            actionBar.setDisplayShowHomeEnabled(true);
            actionBar.setDisplayShowTitleEnabled(true);
            actionBar.setDisplayUseLogoEnabled(false);
            actionBar.setHomeButtonEnabled(true);
        }
        //为Viewpager设置适配器
        ViewPager viewPager = materialViewPager.getViewPager();
        viewPager.setAdapter(new FragmentStatePagerAdapter(getChildFragmentManager()) {
            @NonNull
            @Override
            public Fragment getItem(int position) {
                switch (position % 3){
                    case 0:
                        return RecyclerViewFragment.newInstance(0,mainActivity);
                    case 1:
                        return RecyclerViewFragmentINFO.newInstance(1,mainActivity);
                    case 2:
                        return RecyclerViewFragment.newInstance(1,mainActivity);
                    default:
                        return RecyclerViewFragment.newInstance(1,mainActivity);

                }
            }

            @Override
            public int getCount() {
                return 3;
            }

            @Nullable
            @Override
            public CharSequence getPageTitle(int position) {
                switch (position % 3){
                    case 0:
                        return "DYNAMIC";
                    case 1:
                        return "INFO";
                    case 2:
                        return "药友";
                    default:
                        return "TAPN";
                }
            }
        });
        materialViewPager.getViewPager().setOffscreenPageLimit(materialViewPager
                .getViewPager().getAdapter().getCount());
        materialViewPager.getPagerTitleStrip().setViewPager(materialViewPager.getViewPager());
    }

    @Override
    public void onResume() {
        super.onResume();
        if(User.isLogin){

            iv_avatar_username.setText("Hello"+User.getUser().getUsername());
        }
    }
}
