package com.example.SearchCenter;

import android.content.Context;
import android.graphics.PorterDuff;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.FrameLayout;
import android.widget.TextView;

import androidx.core.content.ContextCompat;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.example.Util.ConditionCode;
import com.example.Util.ReturnData;
import com.example.cmknowledgegraph.R;
import com.loopeer.cardstack.CardStackView;
import com.loopeer.cardstack.StackAdapter;

import java.util.List;

public class CMKGStackAdapter extends StackAdapter<Integer> implements ConditionCode {

    List<List<ContentData>> contentList;
    ReturnData returnData;
    /**
     *
     * 构造函数
     */
    static  int title_num=0;//标题的数目
    public CMKGStackAdapter(Context context, ReturnData returnData)
    {
        super(context);
        //mContext = context;
        this.returnData = returnData;
    }

    protected CardStackView.ViewHolder onCreateView(ViewGroup parent, int viewType) {
        View view = LayoutInflater.from(parent.getContext()).inflate(R.layout.cmkg_item,parent,false);  //通过LayoutInflater加载布局
        CardViewHolder holder = new CardViewHolder(view);
        System.out.println("onCreateView");
        return holder;
    }

    public int getItemViewType(int position) {
        System.out.println("getItemViewType");
        return super.getItemViewType(position);
    }

    /**
     * 该方法决定该列表可以显示多少项卡片，所以你需要根据你传入的数据去，去判断返回多少项。
     */
    public int getItemCount() {
        System.out.println("getItemCount");
        return super.getItemCount();
    }

    /**
     * 重载了StackAdapter中的 updateData(List data)方法，因为不仅仅要传入颜色数组，还有我自己的数据
     * @param data
     * @param lessonList
     */
    public void updateData(List data, List<List<ContentData>> lessonList) {
        this.contentList = lessonList;
        updateData(data);
        System.out.println("Updata!*****************************");
    }

    public void bindView(Integer data, int position, CardStackView.ViewHolder holder) {
        if(holder instanceof CardViewHolder)
        {
            CardViewHolder cardHolder = (CardViewHolder)holder;
            cardHolder.onBind(data,position,contentList,returnData);
        }
        System.out.println("bindView");
    }

    /**
     * 在上面看到了在onCreateView时需要返回一个ViewHolder，将每一项的布局缓存起来，以供后面反复使用。
     */
    public static class CardViewHolder extends CardStackView.ViewHolder
    {
        View root;
        FrameLayout cardTitle;          //布局头部
        RecyclerView scoreList;         //布局头部下方的RecyclerView
        TextView titleText;             //布局头部中的标题
        public CardViewHolder(View view)
        {
            /*
                在创建ViewHolder是 对控件进行绑定
            */
            super(view);
            root = view;
            cardTitle = (FrameLayout)view.findViewById(R.id.card_title);
            titleText = (TextView)view.findViewById(R.id.card_title_text);
            scoreList = (RecyclerView)view.findViewById(R.id.scores_list);
            System.out.println("CardViewHolder constructor");
        }

        public void onBind(Integer backgroundColorId,int position,List<List<ContentData>> dataList,ReturnData returnData)
        {
            /*
                该方法是在bindView 调用时被调用的，因为可能有不同的布局，因而有不同的ViewHolder，将bindView实现的操作放在了ViewHolder中的onBind方法中，会使代码看来起更简洁，易懂。
            */
            /**
             * v                  病-症状：标题是名字，内容是症状
             *          *         病-治疗药品：标题是药的名字，内容是药的用法（暂时不做）
             *          *         药-用法：标题是药的名字，内容是药的用法
             *          *         药-作用：标题是药的名字，内容是药的用法
             */
            if(returnData.getCode()==DiseaseToSymptom||returnData.getCode()==MedicineToOperation){
                //对应病症，那么标题只有一个就是病的名字
                titleText.setText(returnData.getMsg());
            }else if(returnData.getCode()==DiseaseToMedicines){
                //对应治疗方法，那么标题就要有多个
                titleText.setText(SearchEntryActivity.content.get(title_num));
                title_num++;
                if(title_num==SearchEntryActivity.content.size())
                    title_num=0;
            }else{
                if(title_num==0) {
                    titleText.setText(returnData.getMsg());
                    title_num++;
                }
                else {
                    titleText.setText("可以治疗的病症");
                    title_num=0;
                }
            }

            cardTitle.getBackground().setColorFilter(ContextCompat.getColor(getContext(),backgroundColorId), PorterDuff.Mode.SRC_IN);//传入的int值，其实是一个颜色，在这里改变头部的颜色
            System.out.println("========================"+position);
            ListAdapter adapter = new ListAdapter(dataList.get(position));
            scoreList.setLayoutManager(new LinearLayoutManager(getContext()));
            scoreList.setAdapter(adapter);
            System.out.println("holder onBind");
        }

        @Override
        public void onItemExpand(boolean b) {

            /*
            该方法是在，其他Item被展开时，自动隐藏和显示的。
            */
            scoreList.setVisibility(b ? View.VISIBLE : View.GONE);
            System.out.println("holder onItemExpand");
        }
    }

}
