package com.example.Util;

import android.util.Log;

import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;

/*
* 发给tomcat服务器的网络请求类
* @han
* @ongbo
* */
public class cmkgWebServiceGet {
    public static ReturnData executeHttpGet(String args,String address){
        HttpURLConnection connection = null;
        InputStream in = null;

        String path = publicStringUtil.cmkgTomcatURL+address+args;

        Log.i("path-=",path);
        URL url = null;
        try {
            url = new URL(path);
        } catch (MalformedURLException e) {
            e.printStackTrace();
        }
        try {
            //打开连接
            connection = (HttpURLConnection)url.openConnection();
            //设置请求方式
            connection.setRequestMethod("GET");//
            //建立连接超时
            connection.setConnectTimeout(100000);
            //传输数据超时
            connection.setReadTimeout(80000);
            //获取返回结果json数据
            in = connection.getInputStream();
            return parseInfo(in);
        } catch (IOException e) {
            e.printStackTrace();
        }finally {
            if(connection != null){
                connection.disconnect();
            }
            if(in != null){
                try {
                    in.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
        return null;
    }
    //将字节流转换成String
    public static ReturnData parseInfo(InputStream inputStream){
        BufferedReader reader = null;
        String line = "";
        StringBuilder response = new StringBuilder();
        try {
            reader = new BufferedReader(new InputStreamReader(inputStream));
            while((line = reader.readLine()) != null) {
                response.append(line);
            }

            JSONObject jsonObject = null;
            try {
                jsonObject = new JSONObject(response.toString());
            } catch (JSONException e) {
                e.printStackTrace();
            }
            int code = 0;
            try {
                code = jsonObject.getInt("code");
            } catch (JSONException e) {
                e.printStackTrace();
            }
            Log.i("code:",""+code);
            String message = null;
            try {
                message = jsonObject.getString("msg");
            } catch (JSONException e) {
                e.printStackTrace();
            }
            Object data = null;
            try {
                 data = jsonObject.getString("data");
            } catch (JSONException e) {
                e.printStackTrace();
            }
            Log.i("data:",""+data);
            ReturnData returnData = new ReturnData(code,message,data);
            return returnData;
        } catch (IOException e) {
            e.printStackTrace();
        }finally {
            if(reader!=null){
                try {
                    reader.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }

        return null;
    }
}
